<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoGestionComponente }}</strong>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <div class="titSec">
        {{ textoGestionComponente }}
      </div>
      <div class="CampoOblogario">
        Campo requerido
        <span class="tRojo">*</span>
      </div>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            Nombre del Componente
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="componente.descripcion"
              outlined
              solo
              maxlength="50"
              flat
              dense
              :error="$v.componenteVuelidate.descripcion.error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(componente.descripcion, 50)
              "
              background-color="white"
            >
              <template
                v-if="$v.componenteVuelidate.descripcion.$error"
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.componenteVuelidate.descripcion.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.componenteVuelidate.descripcion.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
          <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
            URL del Componente
            <span class="tRojo">*</span>
            <br />
            <v-text-field
              v-model.trim="componente.modulo"
              outlined
              solo
              maxlength="50"
              flat
              dense
              :error="$v.componenteVuelidate.modulo.error"
              hint-align="right"
              :hint="
                'CARACTERES RESTANTES ' +
                  serviceCommons.remaningCharacters(componente.modulo, 50)
              "
              background-color="white"
            >
              <template
                v-if="$v.componenteVuelidate.modulo.$error"
                v-slot:append
              >
                <v-popover placement="bottom-end" color="red" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.componenteVuelidate.modulo.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.componenteVuelidate.modulo.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-text-field>
          </v-col>
        </v-row>
        <v-row>
          <v-col :cols="12" :sm="12" :md="5" :lg="5" :xl="4">
            Es Web
            <span class="tRojo">*</span>
            <br />
            <v-select
              v-model="componente.es_web"
              :items="esWebOptions"
              item-value="es_web_value"
              item-text="es_web"
              solo
              label="Tipo Flujo"
              :error="!$v.componenteVuelidate.es_web.required"
            >
              <template
                v-if="!$v.componenteVuelidate.es_web.required"
                v-slot:append-outer
              >
                <v-popover placement="bottom-end" offset="16">
                  <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                  <template slot="popover">
                    <div
                      @click="$v.componenteVuelidate.es_web.$reset"
                      v-close-popover
                    >
                      <div v-if="!$v.componenteVuelidate.es_web.required">
                        ¡No te olvides de éste campo!
                      </div>
                    </div>
                  </template>
                </v-popover>
              </template>
            </v-select>
          </v-col>
        </v-row>
      </div>
      <div class="btnCenter">
        <v-btn
          class="mr-6"
          depressed
          dark
          tile
          color="secundary"
          @click="dialogCancel = true"
          :class="[{ desac: !hasGlobalChanges }]"
          >Cancelar cambios</v-btn
        >
        <v-btn
          depressed
          dark
          tile
          color="primary"
          @click.stop="guardarCambios"
          :class="[
            { desac: !hasGlobalChanges },
            { desac: savingComponente },
            { 'error-validation-btn': $v.$invalid }
          ]"
          >Guardar cambios</v-btn
        >
      </div>
    </div>
    <template>
      <v-dialog v-model="dialogErrorValidation" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal titModaleError">
              <strong>¡Oh oh!</strong>
              Tienes algunos conflictos de validación
            </div>
          </v-card-title>
          <v-card-text
            >¡No hay de que preocuparse! Solo tienes que
            corregirlos.</v-card-text
          >
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="error"
                @click="dialogErrorValidation = false"
                >Aceptar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogCancel" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¿Seguro que deseas
              <strong>cancelar</strong> los cambios realizados?
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogCancel = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="cancelGlobalChanges()"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              ¡Se han
              <strong>guardado los cambios de manera exitosa!</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                :to="cardComponente.to"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="dialogSave = false"
                >Regresar a Componentes</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <LeavePage ref="LeavePage" />
  </div>
</template>
<style scoped>
.rowInactive .tooltiptext3 .tooltiptext4 {
  visibility: hidden !important;
}
.tooltiptext3 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: relative;
  z-index: 1;
  z-index: 1;
  bottom: 0;
  left: -15px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext4 {
  background-color: #fd5151 !important;
  color: #fff;
  text-align: center;
  padding: 5px 12px;
  white-space: nowrap;
  position: absolute;
  z-index: 1;
  z-index: 1;
  bottom: -30px;
  left: -29px;
  font-weight: 100;
  font-size: 1em;
  transform: scale(0.75);
}
.tooltiptext3:after,
.tooltiptext4:after {
  width: 0;
  height: 0;
  border-style: solid;
  /* border-width: 20px 20px 20px 20px; */
  border-left: 15px solid transparent;
  border-right: 15px solid transparent;
  border-bottom: 15px solid #fd5151;
  border-top: 0px;
  /* border-color: #67ef00 transparent transparent transparent; */
}
.tooltiptext3:after,
.tooltiptext3:before,
.tooltiptext4:after,
.tooltiptext4:before {
  left: 10px;
  top: -45%;
  content: "";
  height: 0;
  width: 0;
  position: absolute;
  pointer-events: none;
}
</style>
<script>
import axios from "axios";
import store from "@/store";
import { required } from "vuelidate/lib/validators";
import LeavePage from "@/views/secure/commons/LeavePage.vue";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
export default {
  name: "Component-GestionComponentes",
  components: {
    LeavePage
  },
  data() {
    return {
      savingComponente: false,
      dialogCancel: false,
      dialogSave: false,
      dialogErrorValidation: false,
      esWebOptions: [
        {
          es_web_value: 1,
          es_web: "Si"
        },
        {
          es_web_value: 2,
          es_web: "No"
        }
      ],
      cardComponente: {
        to: {
          name: "privilegios_flujos_componentes"
        }
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios"
          }
        },
        {
          text: "Flujos",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos"
          }
        },
        {
          text: "Componentes",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios_flujos_componentes"
          }
        }
      ],
      componenteBackup: {
        id_modulo: null,
        descripcion: "",
        modulo: "",
        fecha_creacion: null,
        fecha_modificacion: null
      },
      componente: {
        id_modulo: null,
        descripcion: "",
        modulo: "",
        fecha_creacion: null,
        fecha_modificacion: null
      },
      textoGestionComponente: null
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.componenteBackup) {
        const originalValue = JSON.stringify(this.componenteBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.componente).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.componente.id_modulo === undefined;
      }
    },
    componenteVuelidate() {
      let componenteVuelidate = JSON.parse(JSON.stringify(this.componente));
      return componenteVuelidate;
    }
  },
  validations: {
    componenteVuelidate: {
      descripcion: {
        required
      },
      modulo: {
        required
      },
      es_web: {
        required
      }
    }
  },
  methods: {
    async guardarCambios() {
      this.$v.$touch();
      if (!this.$v.$invalid) {
        var self = this;
        this.componente.id_empleado_modifica = user.empleado;
        this.componente.id_empleado = user.empleado;
        this.savingComponente = true;
        if (this.componente.id_modulo) {
          axios
            .put("/modulo/secure/put", this.componente)
            .then((response) => {
              if (response) {
                const data = response.data;
                if (data.status_code === 200) {
                  self.dialogSave = true;
                  self.componenteBackup = JSON.parse(
                    JSON.stringify(self.componente)
                  );
                } else {
                  console.log("No Update");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingComponente = false;
            });
        } else {
          axios
            .post("/modulo/secure/post", this.componente)
            .then((response) => {
              if (response) {
                const data = response.data;
                if (data.status_code === 200) {
                  self.dialogSave = true;
                  self.componenteBackup = JSON.parse(
                    JSON.stringify(self.componente)
                  );
                } else {
                  console.log("No Insert");
                }
              }
            })
            .catch((error) => {
              console.log(error);
            })
            .finally(function() {
              self.savingComponente = false;
            });
        }
      } else {
        this.dialogErrorValidation = true;
      }
    },
    cancelGlobalChanges() {
      this.componente = JSON.parse(JSON.stringify(this.componenteBackup));
      this.dialogCancel = false;
      this.$v.$reset();
    },
    initValues() {
      if (!this.componente.id_modulo) {
        this.textoGestionComponente = "Crear un Componente";
        this.breadcrumbs.push({
          text: "Nuevo",
          disabled: true
        });
      } else {
        this.breadcrumbs.push({
          text: "Edición",
          disabled: true
        });
        this.textoGestionComponente = "Editar un Componente";
      }
    }
  },
  created() {
    if (this.$route.params.componente) {
      this.componente = this.serviceCommons.base64ToObject(
        this.$route.params.componente
      );
      this.componenteBackup = JSON.parse(JSON.stringify(this.componente));
    }
    this.initValues();
  },
  beforeRouteLeave: function(to, from, next) {
    this.$refs.LeavePage.beforeRouteLeave(
      to,
      from,
      next,
      this.hasGlobalChanges
    );
  }
};
</script>
